unit uFormEditSimSEE;

{$mode delphi}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Menus,
  StdCtrls, ComCtrls, maskedit, ExtCtrls, Grids, PopupNotifier, EditBtn,
  Buttons, DbCtrls, ucosa, uCosaConNombre, contnrs, DifferencesTreeUnit,
  uFormularioBase,
  uFormularioEstatico, uFormularioAutomatico, uInicioYFinal,
  uRegistroDeEditores, uTabsActores, uEstados, uConstantesSimSEE, uInfoCosa,
  usalasdejuego,uEditarEnganches,uescenarios,uVirtualTablesDefs,uGrillasParaEditor,
  uStringGridWithControls;

resourcestring

  rsPosteN = 'Poste Nº';
  rsDuracion = 'Duración';

type

  { TFormEditSimSEE }

  TFormEditSimSEE = class(TFormularioEstatico)
    BAyudaEnganchar: TButton;
    bb_BuscarArchivoCF: TBitBtn;
    bb_BuscarArchivoSala: TBitBtn;
    bb_VaciarArchivoSala: TBitBtn;
    BDefinir_Enganches_SimSEE_Flucar: TButton;
    bb_Buscar_Flucar: TBitBtn;
    BEnganches: TButton;
    BitBtn1: TBitBtn;
    btBuscarCFaux: TBitBtn;
    btVaciarCFAux: TBitBtn;
    btAplicarFiltro: TButton;
    btAyudaGlobales: TButton;
    btCrearNuevoEscenario: TButton;
    btExportarActor_Barra: TButton;
    btImportarActor_Barra: TButton;
    btTodos: TButton;
    bt_VaciarArchivoCF: TBitBtn;
    b_Guardar: TButton;
    CBEstabilizarFrameInicial: TCheckBox;
    GuardarMenuItem: TMenuItem;
    GuardarComoMenuItem: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    TListFuenteAleatoria_capa: TEdit;
    TListFuenteAleatoria_nombre: TEdit;
    TListGeneradorCO2_lst: TPanel;
    SalirMenuItem: TMenuItem;
    N2: TMenuItem;
    N1: TMenuItem;
    rb_EngancharConCF: TRadioButton;
    SaveDialog: TSaveDialog;
    TSalaDeJuego_EngancharConSala: TRadioButton;
    TSalaDeJuego_archivoSala_ParaEnganches: TEdit;
    Label34: TLabel;
    Label40: TLabel;
    lblEngancheEscenario: TLabel;
    p_enganchar_con_cf: TPanel;
    p_enganchar_con_sala: TPanel;
    TGlobs_fechaGuardaSim: TDateEdit;
    TGlobs_fechaFinSim: TDateEdit;
    TGlobs_fechaIniSim: TDateEdit;
    TGlobs_fechaFinOpt: TDateEdit;
    TGlobs_fechaIniOpt: TDateEdit;
    Panel7: TPanel;
    TGlobs_FactorEmisiones_MargenOperativoTipo: TRadioGroup;
    TSalaDeJuego_archivoCF_ParaEnganches: TEdit;
    TSalaDeJuego_engancharconsala_escenario: TComboBox;
    TSalaDeJuego_generarraws: TCheckBox;
    cb_EngancharSala_Escenario: TComboBox;
    eFiltroGeneradores_CO2: TEdit;
    GroupBox6: TGroupBox;
    Label25: TLabel;
    Label26: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label51: TLabel;
    Label61: TLabel;
    Label91: TLabel;
    LOpt1: TLabel;
    LV_Flucar: TListView;
    LV_Simsee_Flucar: TListView;
    Memo1: TMemo;
    Panel: TPanel;
    Panel2: TPanel;
    Panel4: TPanel;
    Panel6: TPanel;
    TGlobs_Deterministico: TRadioGroup;
    TGlobs_CAR_CVaR: TRadioGroup;
    TGlobs_iteracion_flucar_modificar_capacidad: TCheckBox;
    TGlobs_iteracion_flucar_modificar_peaje: TCheckBox;
    TGlobs_iteracion_flucar_modificar_rendimiento: TCheckBox;
    TSalaDeJuego_usarArchivoParaInicializarFrameInicial: TRadioGroup;
    TGlobs_SalaMinutal: TRadioGroup;
    rb_VaR: TRadioButton;
    tcActores: TTabControl;
    TGLobs_calcular_emisionesco2: TCheckBox;
    TGlobs_FactorEmisiones_ProyectoEolicoSolar: TCheckBox;
    TListGenerador_lst: TPanel;
    tsActores: TTabSheet;
    TSalaDeJuego_enganchar_promediando_desaparecidas: TCheckBox;
    TSalaDeJuego_estabilizarinicio: TCheckBox;
    ts_CO2: TTabSheet;
    TSalaDeJuego_usarIteradorFlucar: TCheckBox;
    TGlobs_iteracion_flucar_archivo_flucar: TEdit;
    GroupBox4: TGroupBox;
    Label11: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    p_ncronicasopt: TPanel;
    ts_flucar: TTabSheet;
    TListaEscenarios_lst: TPanel;
    TGlobs_ncronicasopt: TEdit;
    TGlobs_publicarsolovariablesusadasensimres3: TCheckBox;
    TGlobs_semilla_inicial_sim: TEdit;
    Label19: TLabel;
    TGlobs_obligariniciocronicaincierto_1_sim: TCheckBox;
    TGlobs_obligardisponibilidad_1_sim: TCheckBox;
    TGlobs_nmax_iteracionesdelpaso_opt: TEdit;
    TGlobs_semilla_inicial_opt: TEdit;
    TGlobs_nmax_iteracionesdelpaso_sim: TEdit;
    Label18: TLabel;
    TGlobs_SortearOpt: TCheckBox;
    TGlobs_ncronicassim: TEdit;
    TGlobs_NDiscHistoCF: TEdit;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Label10: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label9: TLabel;
    p_usar_car: TPanel;
    TGlobs_car: TEdit;
    TGlobs_obligardisponibilidad_1_opt: TCheckBox;
    TGlobs_problimiteriesgo: TEdit;
    TGlobs_restarutilidadesdelcostofuturo: TCheckBox;
    TGlobs_usar_car: TCheckBox;
    TGlobs_tasadeactualizacion: TEdit;
    ts_simulador: TTabSheet;
    //Label5: TLabel;
    LabelEnganchar1: TLabel;
    p_desde_archivo_cfbin: TPanel;
    TSalaDeJuego_archivocfaux: TEdit;
    TSalaDeJuego_uniformizar_promediando: TEdit;
    GBInicializarCF: TGroupBox;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    ts_estado: TTabSheet;
    TListFuenteAleatoria_lst: TPanel;
    TGlobs_DurPaso_minutos: TEdit;
    TGlobs_durPos: TStringGrid;
    TGlobs_EDurPaso: TEdit;
    TGlobs_ENPasosOpt: TEdit;
    TGlobs_ENPasosSim: TEdit;
    LFechaIni: TLabel;
    gbHorizTiempo: TGroupBox;
    gbPasoTiempo: TGroupBox;
    GroupBox8: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    lblFormatoFecha: TLabel;
    LDurPaso: TLabel;
    LFechaFin: TLabel;
    LNPasosOpt: TLabel;
    LNPasosSim: TLabel;
    LNPostes: TLabel;
    LOpt: TLabel;
    LSim: TLabel;
    MainMenu: TMainMenu;
    Archivo: TMenuItem;
    MenuItem1: TMenuItem;
    AbrirMenuItem: TMenuItem;
    TGlobs_NPostes: TEdit;
    OpenDialog: TOpenDialog;
    pcPrincipal: TPageControl;
    PCPasoDeTiempo: TPageControl;
    TGlobs_PostesMonotonos: TCheckBox;
    tsVariablesGlobales: TTabSheet;
    tsFuentes: TTabSheet;
    TSHorario: TTabSheet;
    TSMinutal: TTabSheet;
    TV_Simsee: TTreeView;

    procedure SaveSalaDeJuego(filename: string='');

    procedure bb_BuscarArchivoSalaClick(Sender: TObject);
    procedure bb_BuscarArchivoCFClick(Sender: TObject);
    procedure bb_Buscar_FlucarClick(Sender: TObject);
    procedure BDefinir_Enganches_SimSEE_FlucarClick(Sender: TObject);
    procedure BEnganchesClick(Sender: TObject);
    procedure btBuscarCFauxClick(Sender: TObject);
    procedure btCrearNuevoEscenarioClick(Sender: TObject);
    procedure btTodosClick(Sender: TObject);
    procedure btVaciarCFAuxClick(Sender: TObject);
    procedure bt_VaciarArchivoCFClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GuardarComoMenuItemClick(Sender: TObject);
    procedure GuardarMenuItemClick(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure AbrirMenuItemClick(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure pcPrincipalChange(Sender: TObject);
    procedure TGlobs_NPostesExit(Sender: TObject);
    procedure TGlobs_SortearOptChange(Sender: TObject);
    procedure TGlobs_usar_carChange(Sender: TObject);
    //procedure rb_desde_archivo_cfbinChange(Sender: TObject);
    procedure tcActoresChange(Sender: TObject);
    procedure TSalaDeJuego_archivoSala_ParaEnganchesChange(Sender: TObject);
    procedure TSalaDeJuego_EngancharConSalaChange(Sender: TObject);
    procedure TSalaDeJuego_engancharconsala_escenarioChange(Sender: TObject);

    //EVENTOS
    procedure TSalaDeJuego_usararchivoparainicializarframeinicialClick(Sender: TObject);

    //**********************************************************************
    //* Eventos Botones Grillas

    procedure Lapiz_OnClick (Sender: TObject; kRow, kCol: Integer);
    procedure Clonar_OnClick (Sender: TObject; kRow, kCol: Integer);
    procedure Borrar_OnClick (Sender: TObject; kRow, kCol: Integer);

    //**********************************************************************

    published

      sgFuentes: TGrillaParaEditor;
      sgActores: TGrillaParaEditor;
      sgEscenarios: TGrillaParaEditor;
      sgGeneradoresCO2:TGrillaParaEditor;


      procedure CrearGrillaFuentes;
      procedure CreateTabActores();
      procedure CreateGrillaEscenarios();
      procedure CreateGrillaGeneradoresCO2();



    public

      filename: string;
      SalaDeJuegoConnectionHandler: TSalaDeJuegoConnection;

      // Las listas de los actores que muestra el listado
      ListasDeActoresTabs: array of TListaDeCosasConNombre;

    constructor Create(TheOwner: TComponent); override;


    function AsignarEventosYCargarControlesEstandar(): boolean; override;


    procedure QueryInical;

    procedure SetEvents(); override;
    procedure RunEvents(); override;

    procedure Free;

  end;

var
  FormEditSimSEE: TFormEditSimSEE;

implementation

{$R *.lfm}

uses
  CosaEditorUnit;

{ TFormEditSimSEE }

procedure TFormEditSimSEE.FormCreate(Sender: TObject);
begin
  inherited;

  self.GuardarMenuItem.Enabled:=false;
  self.GuardarComoMenuItem.Enabled:=false;

  TGlobs_durPos.Cells[0,0]:=rsPosteN;
  TGlobs_durPos.Cells[0,1]:=rsDuracion;

  lblFormatoFecha.Caption := 'Ej.: ' + DateTimeToStr(now());

end;

procedure TFormEditSimSEE.GuardarComoMenuItemClick(Sender: TObject);
begin
  self.SaveDialog:=TSaveDialog.Create(self);
  self.SaveDialog.InitialDir := getDir_Corridas;
  self.SaveDialog.Filter := 'Archivos SimSEEEdit (*.ese)|*.ese|Todos los Archivos (*.*)|*.*';
  self.SaveDialog.InitialDir := getDir_Corridas;
  self.SaveDialog.DefaultExt := 'ese';
  if self.SaveDialog.Execute then
  begin
    self.SaveSalaDeJuego(self.SaveDialog.FileName);
  end;
end;

procedure TFormEditSimSEE.GuardarMenuItemClick(Sender: TObject);
begin
  self.SaveSalaDeJuego();
end;

procedure TFormEditSimSEE.Label3Click(Sender: TObject);
begin

end;

procedure TFormEditSimSEE.Button1Click(Sender: TObject);
begin
  PrintDataSet(self.dataSet);
end;

procedure TFormEditSimSEE.Button2Click(Sender: TObject);
begin

end;

procedure TFormEditSimSEE.btTodosClick(Sender: TObject);
begin

end;

procedure TFormEditSimSEE.btCrearNuevoEscenarioClick(Sender: TObject);
begin

end;

procedure TFormEditSimSEE.btBuscarCFauxClick(Sender: TObject);
var
  filename: String;
  DataCell: TDataCellOfCosa;
  CF: TAdminEstados;
begin
  self.OpenDialog:=TOpenDialog.Create(self);
  self.OpenDialog.Filter := 'Archivos Binarios de Costos Futuros' + ' (*.bin)|*.bin|' +
    'Todos los Archivos' + ' (*.*)|*.*';

  if self.OpenDialog.Execute then
  begin
    self.guardado:=False;

    self.TSalaDeJuego_archivocfaux.Text:=trim(self.OpenDialog.FileName);

    if FileExists(self.TSalaDeJuego_archivocfaux.Text) then
    begin
      self.UpdateDataCell(self.TSalaDeJuego_archivocfaux);
      CF:=TAdminEstados.CreateLoadFromArchi(self.TSalaDeJuego_archivocfaux.Text);
      CF.Free;
    end
    else
      ShowMessage('El archivo' + ' ' + self.TSalaDeJuego_archivocfaux.Text + ' ' + 'no existe.');
  end;
end;

procedure TFormEditSimSEE.SaveSalaDeJuego(filename: string);
var
  ds: TDataStore;
begin
  DATA_STORE.Merge(self.DataSet);
  self.SalaDeJuegoConnectionHandler.WriteDataStoreToTextFile(filename);
  self.guardado:=true;
  MessageDlg('Sala guardada exitosamente.', TMsgDlgType.mtInformation, [TMsgDlgBtn.mbOK], 0);
end;

procedure TFormEditSimSEE.bb_BuscarArchivoSalaClick(Sender: TObject);
var
  saux: TSalaDeJuego;
  lst: TStringList;
  ae: TEscenario_rec;
  k: Integer;
begin
  self.OpenDialog:=TOpenDialog.Create(self.Owner);
  self.OpenDialog.InitialDir := getDir_Corridas;
  self.OpenDialog.Filter := 'Archivos SimSEEEdit (*.ese)|*.ese|Todos los Archivos (*.*)|*.*';

  if self.OpenDialog.Execute then
  begin
    if FileExists(self.OpenDialog.FileName) then
    begin
      self.TSalaDeJuego_archivoSala_ParaEnganches.Text:=self.OpenDialog.FileName;
      self.UpdateDataCell(self.TSalaDeJuego_archivoSala_ParaEnganches);

      guardado := False;
    end
    else
      ShowMessage('El archivo' + ' ' + self.TSalaDeJuego_archivoSala_ParaEnganches.Text + ' ' + 'no existe.');
  end;
end;

procedure TFormEditSimSEE.bb_BuscarArchivoCFClick(Sender: TObject);
var
  CF: TAdminEstados;
begin
  self.OpenDialog:=TOpenDialog.Create(self.Owner);
  self.OpenDialog.InitialDir:=getDir_Run;
  self.OpenDialog.Filter:='Archivos Binarios de Costos Futuros (*.bin)|*.bin|Todos los Archivos (*.*)|*.*';

  if self.OpenDialog.Execute then
  begin
    if FileExists(self.OpenDialog.FileName) then
    begin
      self.TSalaDeJuego_archivoCF_ParaEnganches.Text:=self.OpenDialog.FileName;
      self.UpdateDataCell(self.TSalaDeJuego_archivoCF_ParaEnganches);

      CF := TAdminEstados.CreateLoadFromArchi(self.TSalaDeJuego_archivoCF_ParaEnganches.Text);
      CF.Free;

      guardado := False;
    end
    else
      ShowMessage('El archivo' + ' ' + self.TSalaDeJuego_archivoCF_ParaEnganches.Text + ' ' + 'no existe.');
  end;
end;

procedure TFormEditSimSEE.bb_Buscar_FlucarClick(Sender: TObject);
begin
  self.OpenDialog:=TOpenDialog.Create(self.Owner);
  self.OpenDialog.InitialDir:=getDir_Corridas;
  self.OpenDialog.Filter:='Archivos SimSEEEdit (*.raw)|*.raw|Archivos *.Raw (*.raw)|*.raw';

  if self.OpenDialog.Execute then
  begin
     self.TGlobs_iteracion_flucar_archivo_flucar.Text:=self.OpenDialog.FileName;
     self.UpdateDataCell(self.TGlobs_iteracion_flucar_archivo_flucar);
  end;
end;

procedure TFormEditSimSEE.BDefinir_Enganches_SimSEE_FlucarClick(Sender: TObject
  );
var
  dvt: TDataTableOfCosa;
//  grilla: TGrillasParaEditor;
begin
  //dvt:=self.DataSet.View(uVirtualTablesDefs.VirtualTables.GetVirtualTable('vdt_TGenerador'));
  (*
  grilla:=uGrillasParaEditor.TGrillasParaEditor.Create(self,'grilla',self.DataSet,uVirtualTablesDefs.VirtualTables.GetVirtualTable('vdt_TGenerador'));

//  grilla:=uGrillasParaEditor.TGrillasParaEditor.Create(self,'grilla',self.DataSet,uVirtualTablesDefs.VirtualTables.GetVirtualTable('vdt_TGenerador'), [idd ]);

//  grilla.Parent:=self.TListaEscenarios_lst;
//  grilla.Width:=grilla.Parent.Width;
//  grilla.Height:=grilla.Parent.Height;

//  grilla.Refresh();
  *)
end;

procedure TFormEditSimSEE.BEnganchesClick(Sender: TObject);
var
  sala:TSalaDeJuego;
  ADataSet: TDataStore;
  form: TEditarEnganches;
  filename: TCaption;
begin

  if (self.TSalaDeJuego_engancharConSala.Checked=false) and
     FileExists(self.TSalaDeJuego_archivoCF_ParaEnganches.Text)  then
  begin

    ADataSet:=TDataStore.Create(nil);
    ADataSet.SetName:='AAAAAAAAA';
    self.DataSet.Fill('dt_TSalaDeJuego', 1001, ADataSet);
    ADataSet.CreateClassInstance('dt_TSalaDeJuego', 1001, TCosa(sala));

    form:=TEditarEnganches.Create(self, self.TSalaDeJuego_archivoCF_ParaEnganches.Text, sala);
    if form.ShowModal = mrOk then
      guardado := False;
    form.Free;
  end
  else
    ShowMessage('Debe seleccionar un archivo CF.bin');
end;

procedure TFormEditSimSEE.btVaciarCFAuxClick(Sender: TObject);
var
  dc_ArchivoCFAux: TDataCellOfCosa;
begin
  dc_ArchivoCFAux:=self.LocalDataRow.DataCellList[self.TSalaDeJuego_archivocfaux.Tag];
  dc_ArchivoCFAux.sval:='';
  self.TSalaDeJuego_archivocfaux.Text:='';
end;

procedure TFormEditSimSEE.bt_VaciarArchivoCFClick(Sender: TObject);
var
  dc_EngancharConSala: TDataCellOfCosa;
  dc_ArchivoCF_ParaEnganches: TDataCellOfCosa;
  dc_ArchivoSala_ParaEnganches: TDataCellOfCosa;
begin
  self.TSalaDeJuego_usarArchivoParaInicializarFrameInicial.ItemIndex:=0;
  self.TSalaDeJuego_usararchivoparainicializarframeinicialClick(Sender);

  dc_EngancharConSala:=self.LocalDataRow.DataCellList[self.TSalaDeJuego_engancharConSala.Tag];
  dc_EngancharConSala.sval:='0';

  dc_ArchivoCF_ParaEnganches:=self.LocalDataRow.DataCellList[self.LocalDataTable.GetIndexOfDataColumnByName('TSalaDeJuego_ArchivoCF_ParaEnganches')];
  dc_ArchivoCF_ParaEnganches.sval:='';

  dc_ArchivoSala_ParaEnganches:=self.LocalDataRow.DataCellList[self.LocalDataTable.GetIndexOfDataColumnByName('TSalaDeJuego_ArchivoSala_ParaEnganches')];
  dc_ArchivoSala_ParaEnganches.sval:='';
end;

procedure TFormEditSimSEE.MenuItem1Click(Sender: TObject);
var
  Select: String;
//  frmChild : TEditorForm;
begin

  Select:='*';
  self.DataSet:=TDataStore.Create(DATA_STORE);
  DATA_STORE.Query(Select, 'dt_TSalaDeJuego', self.DataSet);
  self.DataSet.DataTableList[0].AddDataRow( self.DataSet.DataTableList[0].GetDataRowWithDefaulValues() );


end;

procedure TFormEditSimSEE.AbrirMenuItemClick(Sender: TObject);
var

  Select: String;
  frmChild : TFormularioAutomatico;

  i: Integer;

  btn: TEditorTButtonControl;
  dt: TDataTableOfCosa;
  dc: TDataColumnOfCosa;
  dcll: TDataCellOfCosa;
  k: Integer;
  ds: TDataStore;

begin


  //     --->  Deben ser globales!!!!!  <---
  //COSA_WITH_CUSTOMIZEDFORM_LIST:=TFPHashList.Create();
  //COSA_WITH_CUSTOMIZEDFORM_LIST.Add('TFichaLPD', TFichaLPDForm);
  //COSA_WITH_CUSTOMIZEDFORM_LIST.Add('TFichaGTer_Basico', TFichaGTer_BasicoForm);


  if (not self.guardado) and (self.filename<>'') then
    if MessageDlg('La sala actualmente abierta todavía no se ha guardado, si continúa perderá los cambios. ¿Desea continuar?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
      Exit();

  {dfusco@20150420
   Si el usuario quiere abrir otra sala, hay que limpiar la BD.}
  DATA_STORE.Clear();

  self.OpenDialog:=TOpenDialog.Create(self.Owner);
  self.OpenDialog.Filter := 'Sala SimSEE|*.ese';
  if self.OpenDialog.Execute then
  begin
    self.filename:=self.OpenDialog.Filename;

    self.OpenDialog.Free;

    self.SalaDeJuegoConnectionHandler:=TSalaDeJuegoConnection.Create(filename);
    self.SalaDeJuegoConnectionHandler.ReadDataStoreFromTextFile('sala');

    self.QueryInical;

    AsignarEventosYCargarControlesEstandar;

    //PARA CARGAR EL AUTOMATICO

    //ds := TDataStore.Create(DATA_STORE);
    //DATA_STORE.Query('*', 'dt_TSalaDeJuego', 1001, ds );
    //self.GuardarMenuItem.Enabled:=true;
    //self.GuardarComoMenuItem.Enabled:=true;
    //
    //frmChild := TFormularioAutomatico.Create(ds, self, 'chucu');
    //
    //frmChild.ShowModal;







  end;

  //PrintDataSet(DATA_STORE);




end;

procedure TFormEditSimSEE.MenuItem3Click(Sender: TObject);
var
  DTF: TDifferencesTreeForm;
  TreeView:TTreeView;
  filename: String;
  SalaDeJuegoConnectionHandler: TSalaDeJuegoConnection;
  (*
  ds: TDataStore;

  dt: TDataTableOfCosa;
  dc: TDataColumnOfCosa;
  dr: TDataRowOfCosa;

  frmChild : TEditorForm;
  i: Integer;
  *)
begin
  DTF:=TDifferencesTreeForm.Create(self);
  DTF.ShowModal();
  (*
  OpenDialog.Filter := 'Sala SimSEE|*.ese';
  if OpenDialog.Execute then
  begin
    filename := OpenDialog.Filename;
    openDialog.Free;

    SalaDeJuegoConnectionHandler:=TSalaDeJuegoConnection.Create(filename);
    SalaDeJuegoConnectionHandler.CreateSalaDeJuegoDataStore('sala');

    TreeView:=nil;
    DTF:=TDifferencesTreeForm.Create(self);
    DTF.Print(ucosa.DATA_STORE,
              'dt_TSalaDeJuego',
              1001,
              TreeView
    );
    DTF.ShowModal();

  end;
  *)
  (*
  ds:=TDataStore.Create();

  dt:=TDataTableOfCosa.Create('testGrid');

  dt.AddDataColumn(TDataColumnOfCosa.Create('Aatta', TDataTypeIntegerOfCosa));
  dt.AddDataColumn(TDataColumnOfCosa.Create('BddRd', TDataTypeIntegerOfCosa));
  dt.AddDataColumn(TDataColumnOfCosa.Create('CsRss', TDataTypeIntegerOfCosa));
  dt.AddDataColumn(TDataColumnOfCosa.Create('eeeeEEee', TDataTypeIntegerOfCosa));
  dt.AddDataColumn(TDataColumnOfCosa.Create('CtttttttT', TDataTypeIntegerOfCosa));

  dr:= TDataRowOfCosa.Create(dt);
  for i := 0 to dt.DataColumnListCount-1  do
    dr.AddDataCell(TDataCellOfCosa.Create(IntToStr(i)));

  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());

  ds.AddDataTable(dt);

  frmChild:=TEditorForm.Create(ds, TSIUD.TSELECT, nil, 'sala');
  frmChild.ShowModal();
  *)
end;

procedure TFormEditSimSEE.pcPrincipalChange(Sender: TObject);
var
  vdt: TDataVTableOfCosa;
begin

  if pcPrincipal.PageIndex=1 then
  begin
    vdt := VirtualTables.GetVirtualTable('vdt_TFuenteAleatoria');
    sgFuentes.Refresh(vdt);
  end;


end;

procedure TFormEditSimSEE.TGlobs_NPostesExit(Sender: TObject);
begin
  if self.UpdateDataCell(Sender) then
    self.TGlobs_durPos.ColCount:=StrToInt(self.TGlobs_NPostes.Text)+1;
end;

procedure TFormEditSimSEE.TGlobs_SortearOptChange(Sender: TObject);
begin
  self.p_ncronicasopt.Enabled:=self.TGlobs_SortearOpt.Checked;
end;

procedure TFormEditSimSEE.TGlobs_usar_carChange(Sender: TObject);
begin
  self.p_usar_car.Enabled:=self.TGlobs_usar_car.Checked;
end;

(*
procedure TFormEditSimSEE.rb_desde_archivo_cfbinChange(Sender: TObject);
var
  DataTable: TDataTableOfCosa;
  DataRowId: Integer;
  DataColumn: TDataColumnOfCosa;
  DataCell: TDataCellOfCosa;
  sval: string;
begin
  DataTable:=self.DataSet.GetDataTableByName('dt_TSalaDeJuego');
  DataRowId:=DataTable.DataRowList[0]._RowId;

  DataColumn:=DataTable.GetDataColumnByName('usarArchivoParaInicializarFrameInicial');
  DataCell:=DataTable.DataRowList[0].DataCellList[DataColumn.Index];
  DataCell.sval:=BoolToStr(self.rb_desde_archivo_cfbin.Checked);

  p_desde_archivo_cfbin.Enabled:=self.rb_desde_archivo_cfbin.Checked;
end;
*)
procedure TFormEditSimSEE.tcActoresChange(Sender: TObject);
var
  vdt: TDataVTableOfCosa;
begin

  vdt:=uTabsActores.tabsActores[tcActores.TabIndex];
  sgActores.Refresh(vdt);

end;

procedure TFormEditSimSEE.TSalaDeJuego_archivoSala_ParaEnganchesChange(
  Sender: TObject);
var
  saux: TSalaDeJuego;
  lst: TStringList;
  i: Integer;
  e: TEscenario_rec;
  dc_archivoSala_ParaEnganches: TDataCellOfCosa;
  dc_engancharConSala_escenario: TDataCellOfCosa;
begin

  //CARGAR ESCENARIOS
  if TSalaDeJuego_archivoSala_ParaEnganches.Text<>'' then
  begin
    saux := TSalaDeJuego.cargarSala(TSalaDeJuego_archivoSala_ParaEnganches.Text, '', True);
    if saux<>nil then
    begin
      lst:=TStringList.Create;
      for i:=0 to saux.Escenarios.Count-1 do
      begin
        e:=saux.Escenarios.items[i] as TEscenario_Rec;
        lst.Add(e.Nombre);
      end;
      saux.Free;

      TSalaDeJuego_engancharconsala_escenario.Items:=lst;

      dc_archivoSala_ParaEnganches:=self.LocalDataRow.DataCellList[self.TSalaDeJuego_archivoSala_ParaEnganches.Tag];
      dc_engancharConSala_escenario:=self.LocalDataRow.DataCellList[self.LocalDataTable.GetIndexOfDataColumnByName('TSalaDeJuego_engancharConSala_escenario')];

      if dc_archivoSala_ParaEnganches.sval=TSalaDeJuego_archivoSala_ParaEnganches.Text then
        self.TSalaDeJuego_engancharconsala_escenario.ItemIndex:=
          self.TSalaDeJuego_engancharconsala_escenario.Items.IndexOf(dc_engancharConSala_escenario.sval);

    end;
  end;
end;

procedure TFormEditSimSEE.TSalaDeJuego_EngancharConSalaChange(Sender: TObject);
begin
  self.p_enganchar_con_sala.Enabled:=self.TSalaDeJuego_engancharConSala.Checked;
  self.p_enganchar_con_cf.Enabled:=not self.TSalaDeJuego_engancharConSala.Checked;
  self.rb_EngancharConCF.Checked:=not self.p_enganchar_con_sala.Enabled;
end;

procedure TFormEditSimSEE.TSalaDeJuego_engancharconsala_escenarioChange(
  Sender: TObject);
begin
  self.UpdateDataCell(self.TSalaDeJuego_engancharconsala_escenario);
end;

procedure TFormEditSimSEE.TSalaDeJuego_usararchivoparainicializarframeinicialClick
  (Sender: TObject);
var
  bval: Boolean;
begin
  bval:=StrToBool(IntToStr(self.TSalaDeJuego_usarArchivoParaInicializarFrameInicial.ItemIndex));
  self.p_desde_archivo_cfbin.Enabled:=bval;
end;

procedure TFormEditSimSEE.Lapiz_OnClick(Sender: TObject; kRow, kCol: Integer);
var
  ADataSet:TDataStore;
  frmChild: TFormularioBase;

  CosaStrId: String;
  Value: String;
  DataRow: TDataVRowOfCosa;
  From: String;
  ColName: String;
  RowId: Integer;
  DataColumn: TDataColumnOfCosa;
  DataCell: TDataCellOfCosa;
  Grid: TGrillaParaEditor;
  GridPanel: TPanel;

begin

  // Grilla que contiene al boton
  Grid:= TGrillaParaEditor(TSGWC_BitBtn(Sender).Owner);
  // Panel que contiene la grilla
  GridPanel:= TPanel(Grid.Parent);

  DataColumn := self.LocalDataColumnList.Items[GridPanel.Tag];
  DataCell   := self.LocalDataRow.DataCellList[GridPanel.Tag];

  //Obtengo la fila virtual de la tabla y el DataSet de la ventana
  DataRow:=Grid.GetDataRow(kRow);

  ADataSet:= TDataStore.Create(DataSet);

  //El valor a editar
  Value:= DataRow.OriginalDataTableName+'.'+IntToStr(DataRow.OriginalDataRowId);

  From:=DataCell.DataRowOwner.DataTableOwner.TableName;
  //ColName:=frmCurrent.LocalDataColumnList.Items[Parent.Tag].ColumnName;
  RowId:=DataCell.DataRowOwner._RowId;

  ADataSet:=DataSet.PrepareUpdate(From, 'lst', RowId, Value, true //TRUE: en la lupa siempre es un elemento de una lista
  {IsChild(TListaDeCosas, ctrlParent.DataColumn.DataType.ClaseDeCosa)});

  CosaStrId:=copy(DataRow.OriginalDataTableName,4,Length(DataRow.OriginalDataTableName));

  frmChild:= uRegistroDeEditores.OpenForm(self,
                                          CosaStrId,
                                          ADataSet,
                                          self.Caption+' >> '+'lst['+name+']');

  if frmChild.ShowModal() = mrOk then
    self.DataSet.Merge(frmChild.DataSet)

end;

procedure TFormEditSimSEE.Clonar_OnClick(Sender: TObject; kRow, kCol: Integer);
var
  ADataSet:TDataStore;
  frmChild: TFormularioBase;

  CosaStrId: String;
  Value: String;
  DataRow: TDataVRowOfCosa;
  From: String;
  ColName: String;
  RowId: Integer;
  DataColumn: TDataColumnOfCosa;
  DataCell: TDataCellOfCosa;
  Grid: TGrillaParaEditor;
  GridPanel: TPanel;

begin

  // Grilla que contiene al boton
  Grid:= TGrillaParaEditor(TSGWC_BitBtn(Sender).Owner);
  // Panel que contiene la grilla
  GridPanel:= TPanel(Grid.Parent);

  DataColumn := self.LocalDataColumnList.Items[GridPanel.Tag];
  DataCell   := self.LocalDataRow.DataCellList[GridPanel.Tag];

  //Obtengo la fila virtual de la tabla y el DataSet de la ventana
  DataRow:=Grid.GetDataRow(kRow);

  ADataSet:= TDataStore.Create(DataSet);

  //El valor a editar
  Value:= DataRow.OriginalDataTableName+'.'+IntToStr(DataRow.OriginalDataRowId);

  From:=DataCell.DataRowOwner.DataTableOwner.TableName;
  //ColName:=frmCurrent.LocalDataColumnList.Items[Parent.Tag].ColumnName;
  RowId:=DataCell.DataRowOwner._RowId;

  ADataSet:=DataSet.PrepareUpdate(From, 'lst', RowId, Value, true //TRUE: en la lupa siempre es un elemento de una lista
  {IsChild(TListaDeCosas, ctrlParent.DataColumn.DataType.ClaseDeCosa)});

  CosaStrId:=copy(DataRow.OriginalDataTableName,4,Length(DataRow.OriginalDataTableName));

  frmChild:= uRegistroDeEditores.OpenForm(self,
                                          CosaStrId,
                                          ADataSet,
                                          self.Caption+' >> '+'lst['+name+']');

  if frmChild.ShowModal() = mrOk then
    self.DataSet.Merge(frmChild.DataSet)

end;

procedure TFormEditSimSEE.Borrar_OnClick(Sender: TObject; kRow, kCol: Integer);
var
  ADataSet:TDataStore;
  CosaStrId: String;
  Value: String;
  DataRow: TDataVRowOfCosa;
  From: String;
  RowId: Integer;
  DataCell: TDataCellOfCosa;
  Grid: TGrillaParaEditor;
  GridPanel: TPanel;

begin


  // Grilla que contiene al boton
  Grid:= TGrillaParaEditor(TSGWC_BitBtn(Sender).Owner);
  // Panel que contiene la grilla
  GridPanel:= TPanel(Grid.Parent);

  DataCell   := self.LocalDataRow.DataCellList[GridPanel.Tag];

  //Obtengo la fila virtual de la tabla y el DataSet de la ventana
  DataRow:=Grid.GetDataRow(kRow);
  ADataSet:= TDataStore.Create(DataSet);

  From:=DataCell.DataRowOwner.DataTableOwner.TableName;
  RowId:=DataCell.DataRowOwner._RowId;


  if QuestionDlg ('Confirmar eliminación','Mensaje!',mtConfirmation, [mrYes,'Si', mrNo, 'No'],'')=mrYes then
  begin
    ADataSet:=DataSet.PrepareDelete(From, RowId, DataRow.OriginalDataTableName,
      DataRow.OriginalDataRowId);
    self.DataSet.Merge(ADataSet);

    Grid.DeleteRow(kRow);
  end;
end;

procedure TFormEditSimSEE.CrearGrillaFuentes;
var
  str: TStringList;
begin

  sgFuentes:=TGrillaParaEditor.Create(self, TListFuenteAleatoria_lst, 'fuentesAleatorias', self.DataSet);

  sgFuentes.AddTextColumn('NOMBRE',
                          nil,
                          taCenter,
                          clDefault,
                          nil,
                          taLeftJustify,
                          clDefault,
                          True);

  sgFuentes.AddBitBtnsColumn(' ',
                             nil,
                             taCenter,
                             clDefault,
                             [BT_Lapiz, BT_Clonar, BT_Borrar1],
                             ['Editar', 'Clonar', 'Eliminar']);


  sgFuentes.OnLapizClick:= Lapiz_OnClick();
end;

procedure TFormEditSimSEE.CreateGrillaEscenarios;
var
  vdt: TDataVTableOfCosa;
begin
  sgEscenarios:=TGrillaParaEditor.Create(self, TListaEscenarios_lst, 'escenarios', self.DataSet);

  sgEscenarios.AddTextColumn('Nombre', nil, taCenter, clDefault, nil, taLeftJustify, clDefault, True);
  sgEscenarios.AddBitBtnsColumn('-',
                                nil,
                                taCenter,
                                clDefault,
                                [BT_SemaforoVerde, BT_Lapiz, BT_Borrar1, BT_Subir, BT_Bajar, BT_Bajar],
                                ['Activar', 'Editar', 'Eliminar', 'Subir', 'Bajar', 'Cambiar escenario principal']);

  sgEscenarios.OnLapizClick:= Lapiz_OnClick();

  vdt := VirtualTables.GetVirtualTable('vdt_TListEscenario');
  sgEscenarios.Refresh(vdt);
end;

procedure TFormEditSimSEE.CreateGrillaGeneradoresCO2;
var
  vdt: TDataVTableOfCosa;
begin
  sgGeneradoresCO2:=TGrillaParaEditor.Create(self, TListGeneradorCO2_lst, 'generadores', self.DataSet);

  sgGeneradoresCO2.AddTextColumn('Nombre', nil, taCenter, clDefault, nil, taLeftJustify, clDefault, True);
  sgGeneradoresCO2.AddTextColumn('Entrada', nil, taCenter, clDefault, nil, taLeftJustify, clDefault, False);
  sgGeneradoresCO2.AddTextColumn('TCO2/MWh', nil, taCenter, clDefault, nil, taLeftJustify, clDefault, False);
  sgGeneradoresCO2.AddCheckBoxColumn('LCMR', nil, taCenter, clDefault, 'LCMR');
  sgGeneradoresCO2.AddCheckBoxColumn('CMD', nil, taCenter, clDefault, 'CMD');

  sgGeneradoresCO2.OnLapizClick:= Lapiz_OnClick();

  vdt := VirtualTables.GetVirtualTable('vdt_TListGeneradorCO2');
  sgGeneradoresCO2.Refresh(vdt);
end;

function TFormEditSimSEE.AsignarEventosYCargarControlesEstandar: boolean;
var
vdt: TDataVTableOfCosa;

begin
  if inherited AsignarEventosYCargarControlesEstandar then
  begin

    // Inicializa la Grilla de Fuentes Aleatorias
    CrearGrillaFuentes;
    // Inicializa el tab de actores y la grilla
    CreateTabActores;
    CreateGrillaEscenarios();
    CreateGrillaGeneradoresCO2();

  end;
end;

procedure TFormEditSimSEE.SetEvents();
begin

end;

procedure TFormEditSimSEE.RunEvents;
begin

  //ESTADOS
  self.TSalaDeJuego_usararchivoparainicializarframeinicialClick(self.TSalaDeJuego_usarArchivoParaInicializarFrameInicial);
  self.TSalaDeJuego_EngancharConSalaChange(self.TSalaDeJuego_engancharConSala);
  self.TSalaDeJuego_archivoSala_ParaEnganchesChange(self.TSalaDeJuego_archivoSala_ParaEnganches);

  //SIMULADOR
  self.TGlobs_SortearOptChange(self.TGlobs_SortearOpt);
  self.TGlobs_usar_carChange(self.TGlobs_usar_car);

end;

procedure TFormEditSimSEE.Free;
begin

  IgnoranceList.Free;

end;

constructor TFormEditSimSEE.Create(TheOwner: TComponent);
var
  IgnoreTable:string;
  IgnoreList:string;
  p:TIniProcedures;
begin

  inherited Create(TheOwner);

  IgnoreTable:='dt_TSalaDeJuego';
  IgnoreList :='capa,'+
               'nombre,'+
               'descripcion,'+
               'globs,'+
               'gens,'+
               'dems,'+
               'sums,'+
               'nods,'+
               'arcs,'+
               'comerciointernacional,'+
               'usosgestionables,'+
               'listafuentes,'+
               //'estabilizarinicio,'+
               'randseed_sincronizaraliniciodecadacronica,'+
               //'usararchivoparainicializarframeinicial,'+
               //'archivocf_paraenganches,'+
               //'archivosala_paraenganches,'+
               //'engancharconsala,'+
               'engancharconsala_escenario,'+
               //'archivocfaux,'+
               'enganchescontinuos,'+
               'enganchesdiscretos,'+
               //'enganchar_promediando_desaparecidas,'+
               //'uniformizar_promediando,'+
               'combustibles,'+
               //'usariteradorflucar,'+
               //'generarraws,'+
               'plantillassimres3,'+
               'escenarios,'+
               'escenarioactivo,'+
               'flg_ImprimirArchivos_Estado_Fin_Cron'
               ;
  self.IgnoranceList.Add(IgnoreTable,IgnoreList);

  IgnoreTable:='dt_TGlobs';
  IgnoreList :='capa,'+
               'nombre'
               //'Calcular_EmisionesCO2,'+
               //'CAR,'+
               //'CAR_CVaR,'+
               //'Deterministico,'+
               //'FactorEmisiones_MargenOperativoTipo,'+
               //'FactorEmisiones_ProyectoEolicoSolar,'+
               //'iteracion_flucar_Archivo_Flucar,'+
               //'iteracion_flucar_modificar_peaje,'+
               //'iteracion_flucar_modificar_rendimiento,'+
               //'iteracion_flucar_modificar_capacidad,'+
               //'NCronicasOpt,'+
               //'NCronicasSim,'+
               //'NDiscHistoCF,'+
               //'NMAX_ITERACIONESDELPASO_OPT,'+
               //'NMAX_ITERACIONESDELPASO_SIM,'+
               //'ObligarDisponibilidad_1_Opt,'+
               //'ObligarDisponibilidad_1_Sim,'+
               //'ObligarInicioCronicaIncierto_1_Sim,'+
               //'probLimiteRiesgo,'+
               //'publicarSoloVariablesUsadasEnSimRes3,'+
               //'restarUtilidadesDelCostoFuturo,'+
               //'semilla_inicial_opt,'+
               //'semilla_inicial_sim,'+
               //'SortearOpt,'+
               //'TasaDeActualizacion,'+
               //'usar_CAR,'+
               //'SalaMinutal'
               ;
   self.IgnoranceList.Add(IgnoreTable,IgnoreList);

   IgnoreTable:='dt_TListGenerador';
   IgnoreList :='capa,'+
                'nombre,'+
                'n';

   //p:=self.InicializarTabActores;
   //SpecificControls.Add('dt_TListGenerador.lst', );

   self.IgnoranceList.Add(IgnoreTable,IgnoreList);

   IgnoreTable:='dt_TListFuenteAleatoria';
   IgnoreList :='n';
   self.IgnoranceList.Add(IgnoreTable,IgnoreList);

   IgnoreTable:='dt_TListaEscenarios';
   IgnoreList :='capa,'+
                'nombre,'+
                'n';
   self.IgnoranceList.Add(IgnoreTable,IgnoreList);

   //p^:=self.InicializarGrillaEscenarios;
   //SpecificControls.Add('dt_TListaEscenarios.lst', p);

end;

procedure TFormEditSimSEE.CreateTabActores;
var
  tabs: TStringList;
  vdt: TDataVTableOfCosa;

begin

  tabs:=tabsActores.TabsNames;
//  tabs.Add('?');
  tcActores.Tabs := tabs;

  sgActores:=TGrillaParaEditor.Create(self, TListGenerador_lst, 'Lista_generadores', self.DataSet);
  sgActores.AddTextColumn('Nombre', nil, taCenter, clDefault, nil, taLeftJustify, clDefault, True);
  sgActores.AddBitBtnsColumn(' ',
                             nil,
                             taCenter,
                             clDefault,
                             [BT_Lapiz, BT_Clonar, BT_Borrar1],
                             ['Editar', 'Clonar', 'Eliminar']);

  sgActores.OnLapizClick:= Lapiz_OnClick();
  sgActores.OnClonarClick:= Clonar_OnClick();
  sgActores.OnBorrar1Click:= Borrar_OnClick();

end;


procedure TFormEditSimSEE.QueryInical;
var
  sval:string;
  split:TStringList;
  DataTableName: String;
  DataRowId: Integer;
begin
  self.DataSet:=TDataStore.Create(DATA_STORE);

  if self.DataSet.Query('*', 'dt_TSalaDeJuego', 1001, self.dataSet) then
  begin

    //GLOBS:
    self.dataSet.ReadDataCellTextValue('dt_TSalaDeJuego', 1001, 'globs', sval);
    split:=TStringList.Create();
    ExtractStrings(['.'], [], PChar(sval), split);
    DataTableName:= split[0];
    DataRowId:= StrToInt(split[1]);
    self.DataSet.Query('*', DataTableName, DataRowId, self.dataSet);

    //LISTA DE FUENTES:
    self.dataSet.ReadDataCellTextValue('dt_TSalaDeJuego', 1001, 'listaFuentes', sval);
    split:=TStringList.Create();
    ExtractStrings(['.'], [], PChar(sval), split);
    DataTableName:= split[0];
    DataRowId:= StrToInt(split[1]);
    self.DataSet.Query('*', DataTableName, DataRowId, self.dataSet);

    //LISTA DE ESCENARIOS:
    self.dataSet.ReadDataCellTextValue('dt_TSalaDeJuego', 1001, 'escenarios', sval);
    split:=TStringList.Create();
    ExtractStrings(['.'], [], PChar(sval), split);
    DataTableName:= split[0];
    DataRowId:= StrToInt(split[1]);
    self.DataSet.Query('*', DataTableName, DataRowId, self.dataSet);

    //LISTA DE ACTORES:
    self.dataSet.ReadDataCellTextValue('dt_TSalaDeJuego', 1001, 'gens', sval);
    split:=TStringList.Create();
    ExtractStrings(['.'], [], PChar(sval), split);
    DataTableName:= split[0];
    DataRowId:= StrToInt(split[1]);
    split.Free;
    self.DataSet.Query('*', DataTableName, DataRowId, self.dataSet);

  end
  else
  begin
    //Ver cuando la sala en nueva.......
  end;
end;

finalization

  uInicioYFinal.AlFinal;

end.

