unit unit2;

{$mode delphi}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Menus,
  StdCtrls, ComCtrls, ucosa, EditorUnit, contnrs, DifferencesTreeUnit;

type

  { TForm2 }

  TForm2 = class(TForm)
    MainMenu: TMainMenu;
    Archivo: TMenuItem;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    OpenDialog: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
  private
    { private declarations }
  public
    DataSet:TDataStore;
  end;

var
  Form2: TForm2;

implementation

{$R *.lfm}

uses
  CosaEditorUnit;

{ TForm2 }

procedure TForm2.FormCreate(Sender: TObject);
begin

end;

procedure TForm2.MenuItem1Click(Sender: TObject);
var
  Select: String;
  frmChild : TEditorForm;
begin

  Select:='*';
  self.DataSet:=TDataStore.Create();
  DATA_STORE.Query(Select, 'dt_TSalaDeJuego', self.DataSet);
  self.DataSet.DataTableList[0].AddDataRow( self.DataSet.DataTableList[0].GetDataRowWithDefaulValues() );

  frmChild:=TEditorForm.Create(self.DataSet, TSIUD.TINSERT, nil, 'sala');
  frmChild.ShowModal();

end;

procedure TForm2.MenuItem2Click(Sender: TObject);
var
  filename: string;

  Select: String;
  frmChild : TEditorForm;
  SalaDeJuegoConnectionHandler: TSalaDeJuegoConnection;
  i: Integer;

begin

  COSA_WITH_CUSTOMIZEDFORM_LIST:=TFPHashList.Create();
  COSA_WITH_CUSTOMIZEDFORM_LIST.Add('TFichaLPD', TFichaLPDForm);
  COSA_WITH_CUSTOMIZEDFORM_LIST.Add('TFichaGTer_Basico', TFichaGTer_BasicoForm);

  OpenDialog.Filter := 'Sala SimSEE|*.ese';
  if OpenDialog.Execute then
  begin
    filename := OpenDialog.Filename;
    openDialog.Free;

    SalaDeJuegoConnectionHandler:=TSalaDeJuegoConnection.Create(filename);
    SalaDeJuegoConnectionHandler.CreateSalaDeJuegoDataStore('sala');

    Select:='*';

    self.DataSet := TDataStore.Create();
    DATA_STORE.Query(Select, 'dt_TSalaDeJuego', self.DataSet);
    frmChild:=TEditorForm.Create(self.DataSet, TSIUD.TUPDATE, nil, 'sala');
    frmChild.ShowModal();

  end;
end;

procedure TForm2.MenuItem3Click(Sender: TObject);
var
  DTF: TDifferencesTreeForm;
  TreeView:TTreeView;
  filename: String;
  SalaDeJuegoConnectionHandler: TSalaDeJuegoConnection;
  (*
  ds: TDataStore;

  dt: TDataTableOfCosa;
  dc: TDataColumnOfCosa;
  dr: TDataRowOfCosa;

  frmChild : TEditorForm;
  i: Integer;
  *)
begin
  DTF:=TDifferencesTreeForm.Create(self);
  DTF.ShowModal();
  (*
  OpenDialog.Filter := 'Sala SimSEE|*.ese';
  if OpenDialog.Execute then
  begin
    filename := OpenDialog.Filename;
    openDialog.Free;

    SalaDeJuegoConnectionHandler:=TSalaDeJuegoConnection.Create(filename);
    SalaDeJuegoConnectionHandler.CreateSalaDeJuegoDataStore('sala');

    TreeView:=nil;
    DTF:=TDifferencesTreeForm.Create(self);
    DTF.Print(ucosa.DATA_STORE,
              'dt_TSalaDeJuego',
              1001,
              TreeView
    );
    DTF.ShowModal();

  end;
  *)
  (*
  ds:=TDataStore.Create();

  dt:=TDataTableOfCosa.Create('testGrid');

  dt.AddDataColumn(TDataColumnOfCosa.Create('Aatta', TDataTypeIntegerOfCosa));
  dt.AddDataColumn(TDataColumnOfCosa.Create('BddRd', TDataTypeIntegerOfCosa));
  dt.AddDataColumn(TDataColumnOfCosa.Create('CsRss', TDataTypeIntegerOfCosa));
  dt.AddDataColumn(TDataColumnOfCosa.Create('eeeeEEee', TDataTypeIntegerOfCosa));
  dt.AddDataColumn(TDataColumnOfCosa.Create('CtttttttT', TDataTypeIntegerOfCosa));

  dr:= TDataRowOfCosa.Create(dt);
  for i := 0 to dt.DataColumnListCount-1  do
    dr.AddDataCell(TDataCellOfCosa.Create(IntToStr(i)));

  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());

  ds.AddDataTable(dt);

  frmChild:=TEditorForm.Create(ds, TSIUD.TSELECT, nil, 'sala');
  frmChild.ShowModal();
  *)
end;


end.

