unit unitLecturaArchivo;

{$mode delphi}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  uCosaHashList ;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    procedure ProcessFile(SourceList:TStringList; var i:integer; var FPHashList:TCosaHashList);
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  sSourceList: TStringList;
  FPHashList:TCosaHashList;
  split: TStringList;
  i: Integer;
begin

  sSourceList.Free;

  WriteLn(FPHashList.Count);

  FPHashList.print(false);

end;

procedure TForm1.ProcessFile(SourceList: TStringList; var i: integer;
  var FPHashList: TCosaHashList);
var
  Line  : String;
  split: TStringList;
  key: String;
  value: String;
  cfphl: TCosaHashList;
  a: Integer;
  b: String;
  j: Integer;
  item: TCosaHashListItem;

begin

  while i<SourceList.Count-1 do
  begin

      Line:=Trim(SourceList[i]);

      if Copy(Line, 1, 2)='<-' then
        Exit();

      split := TStringList.Create;
      ExtractStrings(['=',';'], [], PChar(Line), split);
      key   := Trim(split[0]);
      value := Trim(split[1]);
      split.Free;

      if Copy(value, 1, 2)='<+' then
      begin
        value:=Copy(value, 3, Length(value)-3);
        cfphl:=TCosaHashList.Create(value);
        i:=i+1;
        ProcessFile(SourceList, i, cfphl);
        item := TCosaHashListItem.CreateHashListItem(cfphl);
        FPHashList.Add(key, item);
      end

      else
      begin
        item:=TCosaHashListItem.CreateValueItem(value);
        FPHashList.Add(key, item);

        if key='n' then
        begin
          cfphl:=TCosaHashList.Create('TList');
          for j:=0 to StrToInt(value)-1 do
          begin
            i:=i+1;
            ProcessFile(SourceList, i, cfphl);
          end;
          item:=TCosaHashListItem.CreateHashListItem(cfphl);
          FPHashList.Add('lst', item);
        end;
      end;
      i:=i+1;
    end;
  end;

end.

