unit uaquoflorida_i;

{$mode delphi}

interface

uses
  Classes, SysUtils, uparques_modeloteorico;

function Create_FloridaI: TParque_ModeloTeorico;

implementation

function Create_FloridaI: TParque_ModeloTeorico;
var
  parque: TParque_ModeloTeorico;
begin

 parque:= TParque_ModeloTeorico.Create_Init('Aquo_Florida', 21, round(360 / 15),
  'Nordex N117',
  'C:\simsee\SimSEE_src\trunk\ax\EstimadorGeneracionERNC\Curvas de potencia\NordexN117_ro1.txt',
  0.8, // alfa_terreno  Mezclador horizontal
  0.5, // gamma_atmosfera  Mezclador Vertical
  1.8, // fpv3pe perdida de pv3 para una pe dada
  -3000, //Aero_xmax
  3000, //Aero_xmin
  1000, //Aero_ymin
  3000, // Aero_ymax
  12, // npuntos_x
  4, // npuntos_y
  9, // grilla_rotada_dx
  1, // grilla_rotada_dy
  1000, // grilla_rotada_margen
  0.0035, // factor_perdidas
  50.0, // potencia-nominal
  50.0 // potencia_autorizada_mw
  );

parque.SetMeteo_UTM(21, 'H', 586441, 6228389);
parque.SetAero_UTM(1, 21, 'H', 583501, 6221188);
parque.SetAero_UTM(2, 21, 'H', 583049, 6221791);
parque.SetAero_UTM(3, 21, 'H', 582756, 6222306);
parque.SetAero_UTM(4, 21, 'H', 581953, 6223194);
parque.SetAero_UTM(5, 21, 'H', 582306, 6223728);
parque.SetAero_UTM(6, 21, 'H', 582569, 6224436);
parque.SetAero_UTM(7, 21, 'H', 581743, 6224930);
parque.SetAero_UTM(8, 21, 'H', 582797, 6226064);
parque.SetAero_UTM(9, 21, 'H', 582531, 6226459);
parque.SetAero_UTM(10, 21, 'H', 582310, 6227148);
parque.SetAero_UTM(11, 21, 'H', 582162, 6227652);
parque.SetAero_UTM(12, 21, 'H', 581465, 6227685);
parque.SetAero_UTM(13, 21, 'H', 580989, 6227954);
parque.SetAero_UTM(14, 21, 'H', 580286, 6228296);
parque.SetAero_UTM(15, 21, 'H', 584327, 6225948);
parque.SetAero_UTM(16, 21, 'H', 584120, 6226372);
parque.SetAero_UTM(17, 21, 'H', 583866, 6227007);
parque.SetAero_UTM(18, 21, 'H', 583554, 6227431);
parque.SetAero_UTM(19, 21, 'H', 586425, 6227663);
parque.SetAero_UTM(20, 21, 'H', 586184, 6228389);
parque.SetAero_UTM(21, 21, 'H', 585799, 6229033);
parque.recalcularCoordenadas;
result:= parque;
end;

end.

