unit uarreglar_codificacion_fuentes;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls,
  Graphics, Dialogs, StdCtrls, DOS, Math;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }


procedure procesar_archivo_ToLowerCase(carpeta, archivo: string);
var
  slc: string;
begin
  slc := LowerCase(archivo);
  RenameFile(carpeta + '\' + archivo, carpeta + '\xxxx_' + slc);
  RenameFile(carpeta + '\xxxx_' + slc, carpeta + '\' + slc);
end;

procedure procesar_archivo(s: string);
var
  f: file of byte;
  a, b, c: byte;
  k: integer;

begin
  assignfile(f, s);
  filemode := 2; // read
  reset(f);
  for k := 0 to 2 do
  begin
    Read(f, a);
    if a = 239 then
    begin
      Read(f, b);
      if b = 187 then
      begin
        Read(f, c);
        if (c = 191) then
        begin
          reset(f);
          Write(f, 32);
          Write(f, 32);
          Write(f, 32);
          writeln('corregido: ', s);
        end;
      end;
    end
    else
    if (a and $80) <> 0 then
    begin
      writeln('sospechozo: ', s);
      readln;
    end;
  end;
  closefile(f);
end;

procedure Procesar_Archivos_de_Carpeta_ToLowerCase(carpeta, mascara: string);
var
  Dir: SearchRec;
begin
  FindFirst(carpeta + '\' + mascara, archive, Dir);
  while (DosError = 0) do
  begin
    if ((Dir.attr and archive) <> 0) then
    begin
      procesar_archivo_ToLowerCase(carpeta, Dir.Name);
    end;
    FindNext(Dir);
  end;
  FindClose(Dir);
end;


procedure Procesar_Archivos_de_Carpeta(carpeta: string);
var
  Dir: SearchRec;
  archi: string;
begin
  FindFirst(carpeta + '\*.pas', archive, Dir);
  while (DosError = 0) do
  begin
    if ((Dir.attr and archive) <> 0) then
    begin
      archi := carpeta + '\' + Dir.Name;
      procesar_archivo(archi);
    end;
    FindNext(Dir);
  end;
  FindClose(Dir);
end;

procedure Procesar_Carpetas_de_Carpeta_ToLowerCase(carpeta: string; mascara: string);
var
  Dir: SearchRec;
begin
  FindFirst(carpeta + '\*', directory, Dir);
  while (DosError = 0) do
  begin
    if ((Dir.attr and directory) <> 0) and (Dir.Name[1] <> '.') and
      (Dir.Name <> 'backup') then
    begin
      //      writeln('Directorio ---> ', carpeta +'\'+ Dir.Name);
      Procesar_Carpetas_de_Carpeta_ToLowerCase(carpeta + '\' + Dir.Name, mascara);
    end;
    FindNext(Dir);
  end;
  FindClose(Dir);

  Procesar_Archivos_de_Carpeta_ToLowerCase(carpeta, mascara);

end;




procedure Procesar_Carpetas_de_Carpeta(carpeta: string);
var
  Dir: SearchRec;
begin
  FindFirst(carpeta + '\*', directory, Dir);
  while (DosError = 0) do
  begin
    if ((Dir.attr and directory) <> 0) and (Dir.Name[1] <> '.') and
      (Dir.Name <> 'backup') then
    begin
      //      writeln('Directorio ---> ', carpeta +'\'+ Dir.Name);
      Procesar_Carpetas_de_Carpeta(carpeta + '\' + Dir.Name);
    end;
    FindNext(Dir);
  end;
  FindClose(Dir);


  Procesar_Archivos_de_Carpeta(carpeta);

end;



procedure procesar_archivo_html_rr(s: string);
var
  fent, fsal: textfile;
  r: ansistring;
  i: integer;
begin

  writeln('Procesando ...: ', s);

  assignfile(fent, s);
  reset(fent);

  assignfile(fsal, 'tmp.txt');
  rewrite(fsal);

  while not EOF(fent) do
  begin
    readln(fent, r);
    i := pos('"/', r);
    while i > 0 do
    begin
      r := copy(r, 1, i) + copy(r, i + 2, length(r) - (i + 1));
      i := pos('"/', r);
    end;

    i := pos('"../', r);
    while i > 0 do
    begin
      r := copy(r, 1, i) + copy(r, i + 3, length(r) - (i + 3) + 1);
      i := pos('"../', r);
    end;

    i := pos('"/', r);
    while i > 0 do
    begin
      r := copy(r, 1, i) + copy(r, i + 2, length(r) - (i + 1));
      i := pos('"/', r);
    end;

    i := pos('''/', r);
    while i > 0 do
    begin
      r := copy(r, 1, i) + copy(r, i + 2, length(r) - (i + 1));
      i := pos('''/', r);
    end;

    writeln(fsal, r);
  end;

  closefile(fsal);
  closefile(fent);

  DeleteFile(s);
  RenameFile('tmp.txt', s);

end;


procedure Procesar_Archivos_de_Carpeta_html_rr(carpeta: string);
var
  Dir: SearchRec;
  archi: string;
begin
  FindFirst(carpeta + '\*.html', archive, Dir);
  while (DosError = 0) do
  begin
    if ((Dir.attr and archive) <> 0) then
    begin
      archi := carpeta + '\' + Dir.Name;
      procesar_archivo_html_rr(archi);
    end;
    FindNext(Dir);
  end;
  FindClose(Dir);
end;


procedure Procesar_Carpetas_de_Carpeta_html_rr(carpeta: string);
var
  Dir: SearchRec;
begin
  FindFirst(carpeta + '\*', directory, Dir);
  while (DosError = 0) do
  begin
    if ((Dir.attr and directory) <> 0) and (Dir.Name[1] <> '.') and
      (Dir.Name <> 'backup') then
    begin
      //      writeln('Directorio ---> ', carpeta +'\'+ Dir.Name);
      Procesar_Carpetas_de_Carpeta_html_rr(carpeta + '\' + Dir.Name);
    end;
    FindNext(Dir);
  end;
  FindClose(Dir);
  Procesar_Archivos_de_Carpeta_html_rr(carpeta);
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  //  Procesar_Carpetas_de_Carpeta('c:\simsee\ALFARO');
  Procesar_Carpetas_de_Carpeta('c:\simsee\SimSEE_src\fron_src');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Procesar_Carpetas_de_Carpeta_html_rr('C:\basura\ieeetdla2012_CD');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Procesar_Carpetas_de_Carpeta_ToLowerCase('c:\simsee\SimSEE_src\fron_src', '*.pas');
  Procesar_Carpetas_de_Carpeta_ToLowerCase('c:\simsee\SimSEE_src\fron_src', '*.pp');
end;



function getlinea(var f: textfile; pal_inis, pal_term: array of string;
  terminador: char): string;
var
  res, r, rc: string;
  comentario_abierto: string;
  buscando_inicio: boolean;
  buscando_fin: boolean;
  ipos, ipos2, k: integer;
  iterm: integer;

begin
  comentario_abierto := '';
  buscando_inicio := True;
  buscando_fin := True;
  res := '';
  iterm := 0;

  while buscando_fin and (iterm = 0) and not EOF(f) do
  begin
    readln(f, rc);
    r := LowerCase(rc);
    ipos := pos('//', r);
    if ipos > 0 then
    begin
      Delete(r, ipos, length(r) - ipos + 1);
      Delete(rc, ipos, length(rc) - ipos + 1);
    end;

    if comentario_abierto <> '' then
    begin
      ipos := pos(comentario_abierto, r);
      if ipos > 0 then
      begin
        Delete(r, 1, ipos);
        Delete(rc, 1, ipos);
      end;
      comentario_abierto := '';
    end;

    if comentario_abierto = '' then
    begin
      ipos := pos('{', r);
      if ipos > 0 then
      begin
        ipos2 := pos('}', r);
        if ipos2 = 0 then
        begin
          comentario_abierto := '}';
          Delete(r, ipos, length(r) - ipos + 1);
          Delete(rc, ipos, length(rc) - ipos + 1);
        end
        else
        begin
          Delete(r, ipos, ipos2 - ipos + 1);
          Delete(rc, ipos, ipos2 - ipos + 1);
        end;
      end;

      ipos := pos('(*', r);
      if ipos > 0 then
      begin
        ipos2 := pos('*)', r);
        if ipos2 = 0 then
        begin
          comentario_abierto := '*)';
          Delete(r, ipos, length(r) - ipos + 1);
          Delete(rc, ipos, length(rc) - ipos + 1);
        end
        else
        begin
          Delete(r, ipos, ipos2 - ipos + 2);
          Delete(rc, ipos, ipos2 - ipos + 2);
        end;
      end;

      if (r <> '') then
      begin
        for k := 0 to high(pal_term) do
        begin
          ipos := pos(pal_term[k], r);
          if iterm > 0 then
            iterm := min(iterm, ipos)
          else
            iterm := ipos;
        end;
        if iterm > 0 then
        begin
          Delete(r, iterm, length(r) - iterm + 1);
          Delete(rc, iterm, length(rc) - iterm + 1);
        end;
      end;

      r := trim(r);
      rc := trim(rc);
      if (r <> '') and buscando_inicio then
      begin
        ipos := 0;
        k := 0;
        while (ipos = 0) and (k <= high(pal_inis)) do
        begin
          ipos := pos(pal_inis[k], r);
          if ipos = 0 then
            Inc(k);
        end;
        if ipos > 0 then
        begin
          res := copy( rc, 1, ipos + length(pal_inis[k]) - 1 );
          Delete(r, 1, ipos + length(pal_inis[k]) - 1);
          Delete(rc, 1, ipos + length(pal_inis[k]) - 1);
          r := trim(r);
          rc := trim(rc);
          buscando_inicio := False;
        end;
      end;

      if (r <> '') and not buscando_inicio then
      begin
        ipos := pos(terminador, r);
        if ipos = 0 then
        begin
          res := trim(res + ' ' + rc);
        end
        else
        begin
          Delete(r, ipos, length(r) - ipos + 1);
          Delete(rc, ipos, length(rc) - ipos + 1);
          res := trim(res + ' ' + rc+terminador);
          buscando_fin := False;
        end;
      end;
    end;
  end;
  if not buscando_fin then
    Result := res
  else
    Result := '';
end;

procedure scan_codigo_procesar_archivo(var fsal: textfile; archi: string);
var
  f: textfile;
  r: string;
  buscando: boolean;
begin
  filemode := 0;
  assignfile(f, archi);
  reset(f);

  writeln(fsal, '**** archivo: ', archi);
  r := getlinea(f, ['program', 'unit'], ['implementation', 'begin'], ';');
  if r <> '' then
  begin
    while r <> '' do
    begin
      writeln(fsal, r);
      r := getlinea(f, ['class ', 'class('], ['implementation', 'begin'], ')');
    end;
  end
  else
    writeln( fsal, 'ojo no encontré ni "program" ni "unit"' );

  writeln(fsal);
  closefile( f );
end;

procedure scan_codigo_Procesar_Archivos_de_Carpeta(var fsal: textfile; carpeta, mascara: string);
var
  Dir: SearchRec;
  archi: string;
begin
  FindFirst(carpeta + '\'+Mascara, archive, Dir);
  while (DosError = 0) do
  begin
    if ((Dir.attr and archive) <> 0) then
    begin
      archi := carpeta + '\' + Dir.Name;
      scan_codigo_procesar_archivo( fsal, archi );
    end;
    FindNext(Dir);
  end;
  FindClose(Dir);
end;

procedure scan_codigo_Procesar_Carpetas_de_Carpeta( var fsal: textfile; carpeta: string);
var
  Dir: SearchRec;
begin
  FindFirst(carpeta + '\*', directory, Dir);
  while (DosError = 0) do
  begin
    if ((Dir.attr and directory) <> 0) and (Dir.Name[1] <> '.') and
      (Dir.Name <> 'backup') then
    begin
      //      writeln('Directorio ---> ', carpeta +'\'+ Dir.Name);
      scan_codigo_Procesar_Carpetas_de_Carpeta( fsal, carpeta + '\' + Dir.Name);
    end;
    FindNext(Dir);
  end;
  FindClose(Dir);
  scan_codigo_Procesar_Archivos_de_Carpeta(  fsal, carpeta, '*.lpr');
  scan_codigo_Procesar_Archivos_de_Carpeta(  fsal, carpeta, '*.dpr');
  scan_codigo_Procesar_Archivos_de_Carpeta(  fsal, carpeta, '*.pp');
  scan_codigo_Procesar_Archivos_de_Carpeta(  fsal, carpeta, '*.pas');
end;


procedure TForm1.Button4Click(Sender: TObject);
var
  fsal: textfile;
  carpeta: string;
begin
  assignfile( fsal, 'c:\basura\scan_condigo.txt' );
  rewrite( fsal );
  carpeta:= 'C:\simsee\SimSEE_src\src';
  scan_codigo_Procesar_Carpetas_de_Carpeta(fsal, carpeta );
  closefile( fsal );
end;

end.

